-- I wonder what this is for?
-- I kid, I kid, this is obviously for SRB2Persona!
-- Hey, you bothered checking the files. If this is included in an unrelated character release, surely this means something... right?
-- PS: SRB2P custom character support works, but is rough.
-- There are NO failsafes if you fuck up declarations, so read the comments here.
freeslot("sfx_frpit", "sfx_frcnfrm1", "sfx_frcnfrm2", "sfx_fritem", "sfx_favow1", "sfx_favow2", "sfx_favow3", "sfx_favow4", "sfx_favdie", "sfx_frheal", "sfx_frhslf", "sfx_fr1mre", "sfx_frdodg", "sfx_frwin", "sfx_frlup", "sfx_frmiss", "sfx_frcrit", "sfx_frask1", "sfx_frask2", "sfx_frask3", "sfx_frdo1", "sfx_frdo2", "sfx_frrlnt1", "sfx_frrlnt2")

if not srb2p return end
-- Due to the exe nature of the mod, this only requires a one-time check.
VFX_freeslotC("frank")
-- Define our base character's stats!
charStats["frank"] = {

		-- GENERAL

		name = "Frank",		-- This is only for bots / enemies
		basehp = 55,			-- base HP for level 1 (Cannot be <= 0)
		basesp = 30,			-- base SP for level 1 (Can be 0, but not < 0!)
		persona = "frank",		-- Persona to use
		melee_natk = "sonic_atk1",	-- normal melee attack

		-- Normal attack attributes
		-- Scales with game difficulty
		atk = 35,	-- power (generally < 50)
		acc = 90,	-- accuracy (%)
		crit = 3,	-- crit rate (%)

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, ["SPR2_CONST"]}
		-- (SPR2 must be a string, and is optional. Only for use with SPR_PLAY)

		-- Note: As of Beta 1.0.0, not all animations are implemented
		-- (* = unimplemented)

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
		anim_stand_bored =	{SPR_PLAY, A, B, C, D, A, B, C, D, 10, "SPR2_WAIT"},	-- standing (rare anim)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_WALK"},		-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},		-- moving
		anim_run =			{SPR_PLAY, A, B, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 1, "SPR2_BNCE"},	-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, B, C, D, E, F, G, H, A, B, C, D, E, F, G, H, 2, "SPR2_PAIN"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- knocked down from weakness / crit
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},		-- dies
		anim_revive =		{SPR_PLAY, A, B, C, D, 2, "SPR2_CLMB"},		-- gets revived
		anim_evoker =		{SPR_PLAY, A, 1, "SPR2_WAIT"},	-- holding evoker to head
		anim_evoker_shoot =	{SPR_PLAY, A, B, C, D, 2, "SPR2_SPIN"},		-- shooting evoker

		anim_stand_super = 	{SPR_PLAY, A, B, C, D, 4, "SPR2_STND"},		-- standing
		anim_stand_hurt_super = 	{SPR_PLAY, A, B, C, D, 4, "SPR2_STND"},		-- standing
		anim_stand_bored_super = 	{SPR_PLAY, A, B, C, D, 4, "SPR2_WAIT"},		-- standing
		anim_run_super = 	{SPR_PLAY, A, B, 2, "SPR2_RUN_"},	-- run
		anim_evoker_super = 	{SPR_PLAY, A, B, C, D, 4, "SPR2_STND"},
		anim_evoker_shoot_super = 	{SPR_PLAY, A, B, C, D, 4, "SPR2_STND"},

		anim_special1 = {SPR_PLAY, F, 1, "SPR2_SPNG"}, -- spind
		anim_special2 = {SPR_PLAY, A, 1, "SPR2_BNCE"}, -- pound special

		-- VOICES
		-- Possible list of voices
		-- vfx_action = {"sfx_voice1", "sfx_voice2", [...], "sfx_voicen"}

		vfx_summon = {},	-- Summoning Persona to use a Skill
        vfx_skill = {"sfx_frcnfrm1", "sfx_frcnfrm2"},		-- Used a Skill
        vfx_item = {"sfx_fritem"},		-- Used an item
        vfx_hurt = {"sfx_favow1", "sfx_favow2", "sfx_favow3", "sfx_favow4"},		-- Sustained damage
        vfx_hurtx = {"sfx_favow1", "sfx_favow2", "sfx_favow3", "sfx_favow4"},		-- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {"sfx_favdie", "sfx_favdie", "sfx_favdie", "sfx_favdie", "sfx_favdie", "sfx_favdie", "sfx_frpit"}, -- currently has a low chance to scream, will change once vfx_tartarus_pit finally works
        vfx_heal = {"sfx_frheal"},		-- Healed by teammate
        vfx_healself = {"sfx_frheal"},	-- Healed self
        vfx_kill = {"sfx_frcnfrm2"},		-- Killed an enemy
        vfx_1more = {"sfx_fr1mre"},		-- Performed 1more
        vfx_crit = {"sfx_frcrit"},		-- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {"sfx_frask1", "sfx_frask2", "sfx_frask3"},	-- Ask to All-Out Attack
        vfx_aoado = {"sfx_frdo1", "sfx_frdo2"},		-- Performing All-Out Attack
        vfx_aoarelent = {"sfx_frrlnt1", "sfx_frrlnt2"},	-- Relenting from All-Out Attack
        vfx_miss = {"sfx_frmiss"},		-- Missed attack
        vfx_dodge = {"sfx_frdodg"},		-- Dodged enemy attack
        vfx_win = {"sfx_frwin"},		-- Battle won
        vfx_levelup = {"sfx_frlup"},	-- level up?
		vfx_tartarus_pit = {"sfx_frpit"}, -- AAAAAAAAAAAAAAAAAAAAAAA [Not implemented yet as far as i'm aware]


		-- HUD DEFINTIIONS

		icon = "ICO_FRNK",	-- icon for net select and other menus
		hudbust = "FRN_H",			-- patch to draw on the stat hud
		hudbustlayer = "",		-- transparent patch to draw for status conditions
		hudaoa = "H_FRNAOA",	-- patch for all out attack hud
		hudcutin = "FRNK_A",	-- cut in
		hudspr = "FRNK",	-- sprite prefix since hud can't retrieve it. yikes
		aoa_quote = "Alright, let's wrap \nthis up!",	-- wity quote shown when character asks for an AOA

		-- Tip to display on the character select.
		-- Give insight on their skill type and their strengths/weaknesses in battle!
		tip = "Can learn Physical and Pierce attacks,\nbut thanks to Tartarus being weird,\nhe can now use Wind and Psychic moves.\nDespite lacking a persona, his stats\nare all-around.",
}		


personaList["frank"] = {
		-- GENERAL
		name = "frank",	-- Name of the Persona
		arcana = ARCANA_FOOL,			-- Arcana (unused in Beta 1.0.0, can be left nil as well)

		sprite = SPR_PSN0,		-- Unused outside of debugging purposes for shortcuts. Can be left nil
		startframe = 0,			-- Unused outside of debugging purposes for shortcuts. Can be left nil

		-- Animations function the same way they do for players. (Frank doesn't own a persona like the others, so it's made invisible)
		anim_idle = 	{SPR_NULL, A},	-- Idle animation when summoned in the menu
		anim_atk = 		{SPR_NULL, A},	-- Animation when attacking

		-- Stats (at level 10)
		-- Remember that stats naturally cap at 99.
		strength = 8,
		magic = 7,
		endurance = 6,
		luck = 5,
		agility = 8,

		-- Affinities (weak, resist, block, drain)
		weak = ATK_ELEC|ATK_CURSE,
		resist = ATK_WIND|ATK_PSY,

		skills = {

					{"lunge", 1}, {"snap", 5}, {"garu", 10},
					{"counter", 12}, {"psi", 13}, 
					{"magaru", 16}, {"mapsi", 20}, 
					{"hard knuckle", 25}, 

					{"triple down", 30, "snap"},
					{"counterstrike", 32, "counter"},
					{"frankpress", 35, "lunge"},
					{"psio", 36, "psi"},
					{"mapsio", 40, "mapsi"},
					{"magarula", 43, "magaru"},
					{"garula", 45, "garu"},
					{"iron fist", 48, "hard knuckle"},

					{"garudyne", 51, "garula"},
					{"gigantic fish", 55, "frankpress"},
					{"psiodyne", 58, "psio"},
					{"delay", 60, "counterstrike"},

					{"road roller", 69, "triple down"},
				},
}

DNG_Abilities["frank"] = {

	jfunc = 	function(p)
					local mo = p.mo

					p.fly1 = 15 -- this is used to speed up the tails
					p.pflags = $ & ~PF_JUMPED
					mo.momx, mo.momy = $/2, $/2
					mo.state = S_PLAY_FLY
					P_SetObjectMomZ(mo, FRACUNIT*12)
					S_StartSound(mo, sfx_zoom)
				end,

	func =		function(p)
					local mo = p.mo

					if mo.p_abl
						-- lower timer for fast tail spinning and play sfx
						p.fly1 = $ and $-1
						if not (leveltime%10)
							S_StartSound(mo, sfx_putput)
						end

						p.pflags = $|PF_CANCARRY

						-- the ability: going up
						if ((mo.eflags & MFE_VERTICALFLIP) and mo.momz < 0)
						or (not (mo.eflags & MFE_VERTICALFLIP) and mo.momz > 0)
							-- reduce speed to 95%
							mo.momx, mo.momy = $*95/100, $*95/100

							-- spawn based advanced ghosts
							if (leveltime%2)
								local g = P_SpawnGhostMobj(mo)
								g.tics = 4
								g.colorized = true
							end
						else
							if (p.cmd.buttons & BT_JUMP) -- slowfall
								P_SetObjectMomZ(mo, gravity*2/3, true)
								--print(-P_GetMobjGravity(mo)*2/3 /FRACUNIT)

								if P_IsObjectOnGround(mo)
									mo.p_abl = false
								end
							else -- fall
								mo.state = S_PLAY_FALL
								mo.p_abl = false
								p.pflags = $ & ~PF_CANCARRY
							end
						end
					end
				end,

}

attackDefs["frankpress"] = {
		name = "Dive Press",
		type = ATK_STRIKE,
		power = 50,
		accuracy = 100,	-- unevadable
		critical = 5,
		target = TGT_ENEMY,
		costtype = CST_SP,
		cost = 20,
		desc = "Unavoidable grab attack\nthat slams the target on the floor.",
		anim_norepel = true,
		physical = true,
		anim = function(mo, targets, hittargets, timer)

			local target = targets[1]
			local atarget = hittargets[1]


			if timer == 1
				ANIM_set(mo, mo.anim_run, true)
				mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)
				mo.slammed = false

				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				S_StartSound(mo, sfx_zoom)
			end

			if not mo.reachedtarget
				mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				P_InstaThrust(mo, mo.angle, FRACUNIT*36)
				if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*36
					mo.reachedtarget = timer
					ANIM_set(mo, mo.anim_special1, true)	-- knux spring state
					mo.momz = FRACUNIT*12
					P_InstaThrust(mo, 0, 0)
					playSound(mo.battlen, sfx_beflap)
				end
			else
				if mo.momz < FRACUNIT and not mo.slammed	-- now we SLAM
					if mo.anim ~= mo.anim_atk
						ANIM_set(mo, mo.anim_atk, true)
					end
					mo.momz = $ - FRACUNIT
				end

				if P_IsObjectOnGround(mo) and not mo.slammed
					P_InstaThrust(mo, mo.angle, -5*FRACUNIT)
					mo.momz = 5*FRACUNIT
					ANIM_set(mo, mo.anim_special2, true)
					target.momz = 5*FRACUNIT

					damageObject(atarget)
					playSound(mo.battlen, sfx_pstop)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
						P_StartQuake(14*FRACUNIT, 10)
					end
					for i=1,16
						local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-3, 3)*FRACUNIT
						b.momy = P_RandomRange(-3, 3)*FRACUNIT
						b.momz = P_RandomRange(4, 16)*FRACUNIT
						b.state = S_AOADUST1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
					for i = 1,32
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (11*(i-1))
						dust.destscale = FRACUNIT*10
						dust.state = S_AOADUST1
						dust.frame = A|FF_FULLBRIGHT
						P_InstaThrust(dust, dust.angle, 20*FRACUNIT)
					end
					mo.slammed = true
				else
					P_TeleportMove(target, target.x, target.y, mo.z)
				end
			end

			if mo.reachedtarget and timer - mo.reachedtarget > 65
				return true
			end
		end,
		critanim = function(mo, targets, hittargets, timer)

			local target = targets[1]
			local atarget = hittargets[1]


			if timer == 1
				ANIM_set(mo, mo.anim_run, true)
				mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)
				mo.slammed = false
				mo.critslam = false

				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				S_StartSound(mo, sfx_zoom)
			end

			if not mo.reachedtarget
				mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				P_InstaThrust(mo, mo.angle, FRACUNIT*36)
				if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*36
					mo.reachedtarget = timer
					ANIM_set(mo, mo.anim_special1, true)	-- knux spring state
					mo.momz = FRACUNIT*12
					P_InstaThrust(mo, 0, 0)
					playSound(mo.battlen, sfx_beflap)
				end
			else
				if mo.momz < FRACUNIT	-- now we SLAM
				and not mo.critslam
					if mo.anim ~= mo.anim_atk
						ANIM_set(mo, mo.anim_atk, true)
					end
					mo.momz = $ - FRACUNIT
					if mo.momz < -15*FRACUNIT
						target.momz = mo.momz*3/2
						mo.momz = 0
						ANIM_set(mo, mo.anim_special2, true)

						mo.critslam = true
					end
				end

				if P_IsObjectOnGround(mo)
					ANIM_set(mo, mo.anim_stand, true)
				end

				if P_IsObjectOnGround(target) and mo.critslam and not mo.slammed
					target.momz = 7*FRACUNIT

					damageObject(atarget)
					playSound(mo.battlen, sfx_pstop)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
						P_StartQuake(14*FRACUNIT, 10)
					end
					for i=1,16
						local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-3, 3)*FRACUNIT
						b.momy = P_RandomRange(-3, 3)*FRACUNIT
						b.momz = P_RandomRange(4, 16)*FRACUNIT
						b.state = S_AOADUST1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
					for i = 1,32
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (11*(i-1))
						dust.destscale = FRACUNIT*10
						dust.state = S_AOADUST1
						dust.frame = A|FF_FULLBRIGHT
						P_InstaThrust(dust, dust.angle, 20*FRACUNIT)
					end
					mo.slammed = true
				else
					if not mo.critslam then P_TeleportMove(target, target.x, target.y, mo.z) end
				end
			end

			if mo.reachedtarget and timer - mo.reachedtarget > 85
				return true
			end
		end,
}