local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
	BattleFuncSet = true
	
	
	local RedRingGun = function(mo,doaction,pressedaction)
		local player = mo.player
		local jumpflags = (player.pflags|PF_JUMPED|PF_THOKKED)&~(PF_STARTJUMP|PF_NOJUMPDAMAGE|PF_GLIDING|PF_BOUNCING|PF_SPINNING)
		player.actiontext = "Shoot Rings"
		player.actionrings = 5
		//Ability start
		if player.actionstate == 0 and doaction == 1 then
			player.actionstate = 1
			player.actiontime = 0
			CBW_Battle.PayRings(player)
			mo.state = S_FRANK_BATTLEGUN
			S_StartSound(frank, sfx_btlgun) //run.
		end	
		
		if player.actionstate == 1 //This state will serve as our startup lag
			player.actiontime = $+1 
			mo.state = S_FRANK_BATTLEGUN
			P_SetObjectMomZ(mo,2*FRACUNIT,0)//Go up if you paid
			mo.player.pflags = jumpflags
			player.drawangle = player.mo.angle //Force facing the direction of the cam.
			CBW_Battle.DrawAimLine(player,mo.angle)
			
			if player.actiontime == 19 then //Set time till next state
				player.actionstate = 2
				player.actiontime = 0
			end
		end
		if player.actionstate == 2 //In this state our character is currently performing their action.
			player.actiontime = $+1
			player.drawangle = player.mo.angle //Force facing the direction of the cam again to be sure..
			CBW_Battle.DrawAimLine(player,mo.angle)
			mo.state = S_FRANK_BATTLEGUN

			if player.actiontime&3==3 //This condition will return true few tics
				then
				local rrgring = P_SPMAngle(mo,MT_REDRING,player.mo.angle,0) 
			end
			CBW_Battle.ApplyCooldown(player,5*TICRATE)
			
			//Reset player state
			if player.actiontime == 20
				player.actionstate = 0
			end
		end
	end

	CBW_Battle.SkinVars["frank"] = {
 		weight = 95,
 		shields = 1,
		special = RedRingGun,
 		guard_enabled = true,
 		guard_frame = 6,
 		func_guard_trigger = CBW_Battle.GuardFunc.Parry,
 		func_priority = CBW_Battle.Priority_FullCommon
	}
end)
addHook("HurtMsg",function(player,inflictor,source) print(CBW_Battle.CustomHurtMessage(player,source,"red ring bullet")) return true end, MT_REDRING)