freeslot("S_FRANK_STAKETRICK", "S_FRANK_BATTLEGUN", "SPR2_BATL", "sfx_btlgun", "S_FRANK_BOUNCE","S_FRANK_DISTRACT", "SPR2_BNCE", "sfx_tramp1", "sfx_tramp2", "sfx_tramp3", "sfx_sbnce1", "sfx_sbnce2", "sfx_sbnce3", "S_PLAY_HYPERTRNS_1")
states[S_FRANK_BATTLEGUN] = {SPR_PLAY, SPR2_BATL, 5, nil, 1, 0, S_PLAY_FALL}
states[S_FRANK_BOUNCE] = {SPR_PLAY, SPR2_BNCE, 50, nil, 1, 0, S_PLAY_FALL}
states[S_FRANK_DISTRACT] = {SPR_PLAY, SPR2_LAND, 3, nil, 0, 0, S_FRANK_DISTRACT}
states[S_FRANK_STAKETRICK] = {SPR_PLAY, SPR2_CLMB, 2, nil, 0, 0, S_FRANK_STAKETRICK}
sfxinfo[sfx_btlgun].caption = "Red Ring Gun Load"
sfxinfo[sfx_tramp1].caption = "Low Bounce"
sfxinfo[sfx_tramp2].caption = "Bounce"
sfxinfo[sfx_tramp3].caption = "High Bounce"
sfxinfo[sfx_sbnce1].caption = "Super Bounce"
sfxinfo[sfx_sbnce2].caption = "High Super Bounce"
sfxinfo[sfx_sbnce3].caption = "Higher Super Bounce"

if not(kirbyabilitytable) //poyo boyo :)
	rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["frank"] = 9

freeslot("SKINCOLOR_FAVYELLOW", "SKINCOLOR_SUPER_FRANK_1", "SKINCOLOR_SUPER_FRANK_2", "SKINCOLOR_SUPER_FRANK_3", "SKINCOLOR_SUPER_FRANK_4", "SKINCOLOR_SUPER_FRANK_5")
//oh god color time
skincolors[SKINCOLOR_FAVYELLOW] = {
	name = "Frank",
	ramp = {81,83,73,73,74,74,75,75,76,77,78,79,235,236,237,238},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = true
	
}

skincolors[SKINCOLOR_SUPER_FRANK_1] = {
	name = "Super Frank 1",
	ramp = {81,83,73,73,74,74,75,75,76,77,78,79,235,236,237,238},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_FRANK_2] = {
	name = "Super Frank 2",
	ramp = {80,81,83,83,73,73,74,75,75,76,76,77,78,78,79,79},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_FRANK_3] = {
	name = "Super Frank 3",
	ramp = {0,80,81,81,84,84,85,86,86,86,86,87,87,87,87,87},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_FRANK_4] = {
	name = "Super Frank 4",
	ramp = {0,0,80,80,81,81,83,83,83,83,84,84,85,85,85,85},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_FRANK_5] = {
	name = "Super Frank 5",
	ramp = {0,0,0,80,80,81,81,81,81,82,82,82,83,83,83,84},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}


//SMS Alfredo allowed me to use his ground pound code from Yoshi, what an awesome guy
local sparks = function(inflictor, ns)
	local i = 0
	
	while i < 15
		local fa = (i*(ANGLE_180/8))
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, MT_IVSP)
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, MT_SUPERSPARK)
		if mo and mo.valid
			mo.momy = FixedMul(cos(fa),ns)
			mo.momx = FixedMul(sin(fa),ns)
		end
		i = $+1
	end
end

local explodelol = function(inflictor, source, radius)
	for mo in mobjs.iterate()
		if not (mo and mo.valid and mo.health)
			continue
		end
		if not (mo.flags & MF_SHOOTABLE) and not (mo.type == MT_EGGGUARD or mo.type == MT_MINUS
		or mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE)
			continue
		end
		if mo.type == MT_PLAYER and not G_RingSlingerGametype()
			continue // Don't hurt players in Co-Op
		end
		if not P_IsObjectOnGround(mo)
			continue
		end
		if abs(inflictor.x - mo.x) > radius or abs(inflictor.y - mo.y) > radius or abs(inflictor.z - mo.z) > radius
			continue // Workaround for possible integer overflow in the below -Red
		end
		if P_AproxDistance(P_AproxDistance(inflictor.x - mo.x, inflictor.y - mo.y), inflictor.z - mo.z) > radius
			continue
		end
		if mo.type == MT_MINUS and not (mo.flags & (MF_SPECIAL|MF_SHOOTABLE))
			mo.flags = (mo.flags & ~MF_NOCLIPTHING)|MF_SPECIAL|MF_SHOOTABLE
		end
		if mo.type == MT_EGGGUARD and mo.tracer //nuke Egg Guard's shield!
			P_KillMobj(mo.tracer, inflictor, source, DMG_NUKE)
		end
		if mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE
			P_KillMobj(mo, inflictor, source, DMG_NUKE) //just murder spikes!
		end
		//Unlike the orignal script this always deals one damage, no matter what
		P_DamageMobj(mo, inflictor, source, 1, DMG_NUKE)
	end
end

//SLW Bounce Attack. Originally made by MotdSpork. I just edited some stuff here and there.
addHook("MobjThinker", function(frank)
	if (frank and frank.skin == "frank") //if you're frank..
	and frank.player.playerstate == PST_LIVE //you alive bruh?
		if frank.player.bounceattack == nil //if the variable doesnt exist
			frank.player.bounceattack = 0 //create variable
		end
		if frank.player.bouncenumber == nil //if the variable doesnt exist
			frank.player.bouncenumber = 0 //create variable
			frank.player.justchangedbouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(frank) //are you on the ground?
		and frank.player.bounceattack == 0 //the player isnt bouncing
			frank.player.bouncenumber = 0 //set it to zero!
		end
		if frank.player.usedown == nil //if the variable doesnt exist
		or not (frank.player.cmd.buttons & BT_SPIN) //not pressing the custom button 1?
			frank.player.usedown = 0 //create variable
			frank.player.justchangedbouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(frank) //Is the player on the ground?
		and (frank.player.cmd.buttons & BT_SPIN) //Is the player holding CUSTOM BUTTON 1?
			frank.player.usedown = 1 //Set it to one!
		end
		
		if (frank.state == S_PLAY_SUPER_TRANS1) //Make sure you won't bounce when you go super!
		or (frank.state == S_PLAY_HYPERTRNS_1)
			frank.player.pflags = $1|PF_THOKKED
		end
		
		if frank.player.pflags & PF_JUMPED //if the player has jumped
		and frank.player.usedown == 0 //make sure you arent holding the spin button.
		and not (frank.player.pflags & PF_THOKKED) //and the player hasnt used their mid-air ability
		and not (P_IsObjectOnGround(frank)) //and you arent on the ground.
		and frank.player.cmd.buttons & BT_SPIN //pressing custom2?
		and frank.player.bounceattack == 0 //checking if the custom variable it set to 0
		and not (frank.player.exiting) //not...exiting the level?
		and frank.health //you're alive?
		and not (P_PlayerInPain(frank.player)) //not hurt are you?
			frank.player.pflags = $1|PF_THOKKED
			frank.player.bounceattack = 1 //set it to one!
			if (frank.player.powers[pw_super])
				P_SetObjectMomZ(frank, -50*FRACUNIT)
				S_StartSound(frank.player.mo, sfx_zoom)
			else 
				P_SetObjectMomZ(frank, -40*FRACUNIT)
			end 
			
		end
		
		if frank.player.bounceattack == 1
			local sectorthing = P_PlayerTouchingSectorSpecial(frank.player, 0, 0)//break da groudnn
			if sectorthing.valid then
				for fof in sectorthing.ffloors()
					if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
					and not (frank.tracer and frank.tracer.type == MT_TUBEWAYPOINT)
					and not frank.player.powers[pw_carry]
					and (abs(fof.topheight - frank.player.mo.z) <= 30*frank.player.mo.scale) then
						EV_CrumbleChain(frank.player.sectorthing, fof)
					end
				end
			end
		end
		
		
		if (frank.eflags & MFE_JUSTHITFLOOR) //you're on the ground.
		and not (frank.player.pflags & PF_SPINNING) //you arent spinning...
		and not (frank.player.pflags & PF_STARTDASH) //you arent doing a spindash
		and not (frank.tracer and frank.tracer.type == MT_TUBEWAYPOINT) //not in a zoomtube?
		and frank.player.bounceattack == 1 //our custom variable is one right...?
		and frank.health //is the player alive..?
		and not (P_PlayerInPain(frank.player)) //not hurt are you?
			if frank.player.bouncenumber == 0 //if he hasnt bounced yet
			and frank.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
				frank.player.justchangedbouncenumber = 1 //now he has!
				frank.player.bouncenumber = 1 //Set this to one!
				frank.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				if (frank.player.powers[pw_super])
					P_SetObjectMomZ(frank, 14*FRACUNIT)
					S_StartSound(frank, sfx_sbnce1)
					sparks(frank.player.mo, 10 << FRACBITS)
					explodelol(frank.player.mo, frank.player.mo, 180*FRACUNIT)
				else
					P_SetObjectMomZ(frank, 10*FRACUNIT)
					S_StartSound(frank, sfx_tramp1)			
				end
				if frank.player.hyper and frank.player.hyper.capable and frank.player.powers[pw_super]
					P_SetObjectMomZ(frank, 17*FRACUNIT)
					S_StartSound(frank.player.mo, sfx_s3k96)
					explodelol(frank.player.mo, frank.player.mo, 250*FRACUNIT)
					sparks(frank.player.mo, 25 << FRACBITS)
				end
				if not (frank.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					frank.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			if frank.player.bouncenumber == 1 //if it's currently on his first bounce
			and frank.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
			and not (P_PlayerInPain(frank.player)) //not hurt are you?
				frank.player.justchangedbouncenumber = 1 //now he has!
				frank.player.bouncenumber = 2 //set this to two!
				frank.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				if (frank.player.powers[pw_super])
					P_SetObjectMomZ(frank, 17*FRACUNIT)
					S_StartSound(frank.player.mo, sfx_sbnce2)
					sparks(frank.player.mo, 10 << FRACBITS)
					explodelol(frank.player.mo, frank.player.mo, 180*FRACUNIT)
				else 
					P_SetObjectMomZ(frank, 14*FRACUNIT)
					S_StartSound(frank.player.mo, sfx_tramp2)
				end
				if frank.player.hyper and frank.player.hyper.capable and frank.player.powers[pw_super]
					P_SetObjectMomZ(frank, 22*FRACUNIT)
					S_StartSound(frank.player.mo, sfx_s3k96)
					explodelol(frank.player.mo, frank.player.mo, 250*FRACUNIT)
					sparks(frank.player.mo, 25 << FRACBITS)
				end
				if not (frank.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					frank.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			if frank.player.bouncenumber == 2 //if it's currently on his second bounce
			and frank.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
			and not (P_PlayerInPain(frank.player)) //not hurt are you?
				frank.player.justchangedbouncenumber = 1 //now he has!
				frank.player.bouncenumber = 0 //set it back to zero
				frank.state = S_FRANK_BOUNCE //it's the funny pose......
				if (frank.player.powers[pw_super])
					P_SetObjectMomZ(frank, 22*FRACUNIT)
					S_StartSound(frank, sfx_sbnce3)
					sparks(frank.player.mo, 10 << FRACBITS)
					explodelol(frank.player.mo, frank.player.mo, 180*FRACUNIT)
				else 
					P_SetObjectMomZ(frank, 17*FRACUNIT)
					S_StartSound(frank, sfx_tramp3)
				end
				if frank.player.hyper and frank.player.hyper.capable and frank.player.powers[pw_super]
					P_SetObjectMomZ(frank, 27*FRACUNIT)
					S_StartSound(frank.player.mo, sfx_s3k96)
					explodelol(frank.player.mo, frank.player.mo, 250*FRACUNIT)
					sparks(frank.player.mo, 25 << FRACBITS)
				end
				frank.player.pflags = $1 & ~PF_JUMPED
			end
			frank.player.bounceattack = 0 //set it back to zero.
			frank.player.usedown = 1 //set it to one.
			frank.player.pflags = $1 & ~PF_THOKKED //uncheck the thokked flag, allowing you to bounce again.
		end
		
		//some quick checks
		if frank.player.bounceattack == 1 //checking our variable.
		and frank.health //and you're alive
		and not (P_PlayerInPain(frank.player)) //not hurt are you?
			P_SpawnThokMobj(frank.player) //spawn the players thok object
			if not (frank.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
				frank.state = S_PLAY_ROLL //force the player into a spinning state.
			end
			if (frank.momz > (9000*P_MobjFlip(frank))) // the player is going up...?  
				P_SetObjectMomZ(frank, FixedMul(-40*FRACUNIT, frank.scale))
			end
		else 
			frank.player.bounceattack = 0 //set it to 0
		end
		if frank.player.bounceattack == 1 //checking if hes bouncing
			frank.player.pflags = $1 & ~PF_SPINNING // you're no longer "spinning" if you were before
		end
		if not (frank.player.pflags & PF_JUMPED) // if you are not actuallly jumping
			frank.player.bounceattack = 0 //set this back to zero to be safe
		end
		if frank.eflags & MFE_GOOWATER //is the player in THZ goop?
		or frank.player.powers[pw_carry] //is the player being carried?
		or frank.player.powers[pw_carry] == CR_MACESPIN
			frank.player.bounceattack = 0 //set to zero!
		end
		if frank.player.powers[pw_carry] == CR_ROLLOUT
		and(frank.eflags & MFE_JUSTHITFLOOR)
			if frank.player.bouncenumber > 0
				S_StartSound(frank, sfx_mario1)
				frank.player.bouncenumber = 0
				frank.player.bounceattack = 0
				frank.player.pflags = $1 & ~PF_JUMPED
				frank.player.pflags = $1 & ~PF_SPINNING
				frank.state = S_PLAY_STND
			end
		end
		if frank.player.powers[pw_carry] == CR_ROLLOUT //stop rolling on it
		and frank.state == S_PLAY_ROLL
			frank.state = S_PLAY_STND
			S_StartSound(frank, sfx_mario1)
		end
		if not (frank.player.pflags & PF_JUMPED) //if the player hasnt jumped
			frank.player.bounceattack = 0 //set this to zero
		end
	end
end, MT_PLAYER)


//distraction time
addHook("PlayerSpawn", function(player)
	player.distracting = false
	P_RestoreMusic(player)
	player.pflags = $1 & ~PF_FULLSTASIS
	if player.mo.state == S_FRANK_DISTRACT
		player.mo.state = S_PLAY_STND
	end
	if player.mo and player.mo.valid and player.mo.skin == "frank"	
		if player.powers[pw_carry] != CR_NIGHTSMODE then player.mo.state = S_PLAY_STND end
	end
end)

addHook("ShouldJingleContinue", function(player, musname)
	if true return end
	if musname != "DSTRCT" or musname != "SDSTRCT" return end
	if player and player.mo and player.mo.skin == "frank" and player.distracting
		return true
	else
		return false
	end
end)

addHook("PlayerThink", function(player)
	if srb2p return end //stop breaking my persona >:(
	if player.mo and player.mo.valid and player.mo.skin == "frank"	
		
		//Detect when we press Toss Flag
		if not (player.cmd.buttons & BT_TOSSFLAG)
			player.canpushflagfav = true
			player.pushingflagfav = false
		elseif player.canpushflagfav 
			player.pushingflagfav = true
			player.canpushflagfav = false
		else
			player.pushingflagfav = false
		end
		if G_IsSpecialStage()
		or player.panim == PA_PAIN
		or player.panim == PA_DEAD
		or player.mo.state == S_PLAY_DEAD
			player.canpushflagfav = false
			player.pushingflagfav = false
		end
		
		
		if player.distracting
			if not (P_IsObjectOnGround(player.mo))
			and player.mo.state != S_PLAY_ROLL and not player.mo.state != S_PLAY_SPINDASH

			or player.pushingflagfav
				if player.mo.state == S_FRANK_DISTRACT
					if player.playerstate != PST_LIVE
						player.mo.state = S_PLAY_DEAD
					else
						player.mo.state = S_PLAY_STND
					end
				end
				player.distracting = false
				P_RestoreMusic(player)
			else
				if player.mo.state != S_FRANK_DISTRACT
					player.mo.state = S_FRANK_DISTRACT
				end
				player.pflags = $|PF_FULLSTASIS
			end
			if player.powers[pw_carry] == CR_MACESPIN
			or (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
				player.mo.state = S_PLAY_ROLL
				player.distracting = false
				P_RestoreMusic(player)
			end
		elseif P_IsObjectOnGround(player.mo)
		and player.mo.state != S_PLAY_ROLL and not player.mo.state != S_PLAY_SPINDASH
		and player.pushingflagfav
			player.distracting = true
			if (player.powers[pw_super])
				P_PlayJingleMusic(player, "SDSTRCT", nil, true, JT_OTHER)
			else
				P_PlayJingleMusic(player, "DSTRCT", nil, true, JT_OTHER)
			end
		end
	else
		if player.distracting
			if player.mo.state == S_FRANK_DISTRACT
				player.mo.state = S_PLAY_STND
			end
			player.distracting = false
			P_RestoreMusic(player)
		end
	end
end)

//sweet flips bro
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "frank"	
		if not (P_IsObjectOnGround(player.mo))
		and player.mo.state == S_PLAY_RUN
		and player.mo.state != S_PLAY_ROLL
			player.mo.state = S_FRANK_STAKETRICK
		end
	end
end)